<?php
//---------------------------------------------------------------------------
//Charactor set is UTF-8
//漢字コードはＵＴＦ－８
//---------------------------------------------------------------------------
//設定ファイル
//編集不可
//---------------------------------------------------------------------------
error_reporting(E_ALL);								//エラー表示レベル設定 デフォルトは (E_ALL ^ E_NOTICE)
date_default_timezone_set('Asia/Tokyo');			//php.ini の date.timezone で設定するが念のため
//---------------------------------------------------------------------------
define('kDSN', 'mysql:host=localhost;dbname=%s;charset=utf8mb4');			//Data Source Name
define("kUSER_TABLE", "asuna_user_table");
define("kLOG_TABLE",  "asuna_log_table");
define('kCSV_CharSet', 'sjis-win');											//CSV出力の時の文字コード sjis-win , utf-8 , euc-jp , jis , iso-2022-jp など
define('kLogin',     'asn_Login' .      kCookieSuffix);						//クッキーの名前
define('kUserID',    'asn_UserID' .     kCookieSuffix);
define('kSection',   'asn_Section' .    kCookieSuffix);
define('kUserName',  'asn_UserName' .   kCookieSuffix);
define('kUserLevel', 'asn_UserLevel' .  kCookieSuffix);
define('kPage',      'asn_Page' .       kCookieSuffix);
define('kTable',     'asn_Table' .      kCookieSuffix);
define('kSortCol',   'asn_SortCol' .    kCookieSuffix);
define('kSortOrder', 'asn_SortOrder' .  kCookieSuffix);
//---------------------------------------------------------------------------
$gTables2 = array(kUSER_TABLE, kLOG_TABLE);									//ユーザーテーブル、ログテーブル 管理者はアクセスできる
$gPDOOption = array(
	//PDO::MYSQL_ATTR_INIT_COMMAND => "SET SESSION sql_mode='TRADITIONAL'",	//カラム型に合わない値がINSERTされようとしたときSQLエラーとする 文字数超過でもエラーになる
	PDO::MYSQL_ATTR_INIT_COMMAND => "SET SESSION sql_mode='NO_AUTO_VALUE_ON_ZERO,ONLY_FULL_GROUP_BY'",	//文字数超過でエラーにならないようにしておく＝手抜き
	PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,							//SQLエラー発生時にPDOExceptionをスローさせる
	PDO::ATTR_EMULATE_PREPARES => false,									//プリペアドステートメントのエミュレーションを無効化する　静的プレースホルダ
	PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC						//fetchのデフォルトはカラム名 カラム名をキーとする連想配列で取得する
);
//SET SESSION sql_mode='TRADITIONAL,NO_AUTO_VALUE_ON_ZERO,ONLY_FULL_GROUP_BY'
//sql_modeにTRADITIONALが入っていると、入力文字数超過の際にエラーが出る。
//  「編集者」カラムは、編集ごとに名前を追加してゆく。TRADITIONALモードにしておくと
//  文字数が超過してエラーが出てしまうので、文字数を十分取るかプログラムを変更する必要がある。
//@link https://www.wakuwakubank.com/posts/414-mysql-sqlmode/ (2021/07確認)
//@link https://qiita.com/tentatsu/items/fd2177777412ebc2f6b9 (2021/07確認)
//@link http://www.songmu.jp/riji/entry/2015-07-08-kamipo-traditional.html (2021/07確認)
//@link https://dev.mysql.com/doc/refman/5.6/ja/sql-mode.html (2021/07確認)
//---------------------------------------------------------------------------
