//---------------------------------------------------------------------------
//Charactor set is UTF-8
//漢字コードはＵＴＦ－８
//---------------------------------------------------------------------------
//テーブル表示関係
//---------------------------------------------------------------------------
//別ウインドウを開くときのオプション
var gWindowOpenOption = 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes';
//window.open のオプションはブラウザによって実装が違う
//location , status , resizable は効かない
// @link https://qiita.com/yun_bow/items/356f21fc376133037d84 (2021/07確認)
///１つ指定するとデフォルトが全部消える
//---------------------------------------------------------------------------
/**
 * 初期設定
 */
$(document).ready(function () {
	$.ajaxSetup({
		async: false, 						//同期通信にする
		cache: false						//キャッシュを無効にする
	});

	$('#EditItemForm :image').click(OpenEditWindow);			//EditItemFormのイメージボタンにクリックイベントを付ける
	$("#ViewTableForm [name='KeyWords']").change(function () {	//表示条件が変わったとき
		$("#ViewTableForm [name='Page']").val("1");
	});
	$("#Table").change(TableSelectChanged);						//Table選択メニューが変えられた
	$("#DelRowButton").click(ConfirmDel);						//行削除ボタン
	$("#TruncateButton").click(ConfirmTruncate);				//空にするボタン
});
//---------------------------------------------------------------------------
/**
 * イメージボタンによる処理分岐
 * 入力、表示、編集、複製の場合は、別ウインドウを開いて入力・編集を行う。submitを中断
 * 削除,並び替え,CSV出力の場合は、コマンドをセットしてフォームを送信
 */
function OpenEditWindow() {
	var prm, ttl;
	var today = new Date();

	table = $("#EditItemForm [name='Table']").val();
	if (table == '') {
		alert("表示するテーブルが変更されています。\n「検索・表示」をクリックして再度テーブルを表示させてください。");
		return false;
	}

	$("#EditItemForm [name='Cmd']").val(this.name);			//コマンド設定
	switch (this.name) {
		case '並び替え':									//何もしないでEditItemFormを送信する
			break;
		case 'CSV出力':
			break;
		case '削除':										//削除、表示、編集、複製
		case '表示':
		case '編集':
		case '複製':
			item = $("#EditItemForm input[name='PrimarykeyVal']:checked").val();
			if (item == undefined) {
				alert("データが選択されていません");
				return false;
			}
		//breakせず、次のcase '新規'に続く
		case '新規':
		case '空にする':
			prm = 'index.php?' + $('#EditItemForm').serialize();
			ttl = 'EditWindow' + today.getTime();
			window.open(prm, ttl, gWindowOpenOption);
			return false;									//submitを中断する
			break;
		default:
			alert("不明なコマンドです");
			return;
	}
	//EditItemFormを送信する
}
//---------------------------------------------------------------------------
/**
 * テーブル選択が変更された
 * ViewTableFormの内容リセット
 * EditItemFormの内容リセット
 */
function TableSelectChanged() {
	//ViewTableFormの内容リセット
	$("#ViewTableForm [name='SortCol']").val("");
	$("#ViewTableForm [name='SortOrder']").val("");
	$('#Page > option').remove();
	$("#Page").append('<option value="1" selected>1</option>');
	$("#ViewTableForm [name='KeyWords']").val("");
	$("#info1").text("(テーブルが変更されました。再度検索してください)")

	//EditItemFormの内容リセット
	$("#EditItemForm [name='Table']").val("");
	$("#EditItemForm [name='Page']").val("");
	$("#EditItemForm [name='KeyWords']").val("");
	$("#ViewTableForm [name='SortCol']").val("");
	$("#ViewTableForm [name='SortOrder']").val("");
}
//---------------------------------------------------------------------------
/**
 * 行削除ボタンが押されたので確認する
 */
function ConfirmDel() {
	ret = confirm("データを削除してもよろしいですか？。\nこの操作は戻すことができません。");
	if (!ret) return;
	$("#DelRowForm").submit();
}
//---------------------------------------------------------------------------
/**
 * テーブルを空にするボタンが押されたので確認する
 */
function ConfirmTruncate() {
	ret = confirm("テーブルのデータをすべて削除してもよろしいですか？。\nこの操作は戻すことができません。");
	if (!ret) return;
	$("#TruncateForm").submit();
}
//---------------------------------------------------------------------------
