<?php
//---------------------------------------------------------------------------
//Charactor set is UTF-8
//漢字コードはＵＴＦ－８
//---------------------------------------------------------------------------
//テーブル編集関係
//---------------------------------------------------------------------------
/**
 * 行の編集ウインドウを作る
 *
 * @param string $_REQUEST['Cmd'] : コマンド 新規 , 編集 , 複製
 * @param string $_REQUEST['Table'] : 選択しているテーブルの番号
 * @param string $_REQUEST['PrimarykeyName'] : プライマリーキーの名前
 * @param string $_REQUEST['PrimarykeyVal'] : プライマリーキーの値
 *
 */
function EditRowWin()
{
	global $gTables;
	//---------------処理部---------------
	$msg = '';
	try {
		$primary_key = GetColumns($fields, $columns);						//カラムの情報を得る
		switch ($_REQUEST['Cmd']) {											//編集用データを作る
			case '新規':
				$cmd = '行追加';
				$_REQUEST['PrimarykeyVal'] = '';
				$editdata = NewEditData($fields);							//新規データを作る
				break;
			case '編集':
				$cmd = '行変更';
				$editdata = GetEditData($primary_key);						//編集データを得る
				break;
			case '複製':
				$cmd = '行追加';
				$editdata = GetEditData($primary_key);						//複製データを得る
				break;
		}
		if (is_array($editdata)) {
			$tbody = MakeEditTable($columns, $editdata, $primary_key);		//表示するテーブルのデータを作る
			$PrimarykeyVal = htmlspecialchars($_REQUEST['PrimarykeyVal'], ENT_QUOTES, 'UTF-8');
		} else {
			$msg = sprintf("<div class=\"error msgbox\">%s <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n", $editdata);	//見つからなかったというエラー
		}
		WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], $msg);
	} catch (PDOException $e) {
		$err = sprintf("%s\n(%s  %d)", $e->getMessage(), $e->getFile(), $e->getLine());
		$id = WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], '', $_REQUEST['Cmd'], $err);
		$msg = "<div class=\"error msgbox\">データベースへの接続に失敗しました。(ログID:{$id}) <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
	}

	$table = htmlspecialchars($_REQUEST['Table'], ENT_QUOTES, 'UTF-8');
	$pkey  = htmlspecialchars($_REQUEST['PrimarykeyName'], ENT_QUOTES, 'UTF-8');
	//---------------表示部---------------
	include("prog/html01.inc");
	printf("<header>\nデータ入力・編集\n</header>\n\n");
	if ($msg == '') {
		//編集の表示
		print <<< kEditRowWin1
<section>
	<form action="index.php" id="EditForm" method="post">
		<input type="hidden" name="Cmd" value="{$cmd}">
		<input type="hidden" name="Table" value="{$table}">
		<input type="hidden" name="PrimarykeyName" value="{$pkey}">
		<input type="hidden" name="PrimarykeyVal" value="{$PrimarykeyVal}">
		<table>
			<tbody>

kEditRowWin1;
		foreach ($tbody as $val) {
			echo $val;
		}
		print <<< kEditRowWin2
			</tbody>
		<tfoot>
			<tr>
			<td colspan="2" class="right">
			<input type="button" value="閉じる" onclick="window.close();">
			<input type="reset"  value="リセット">
			<input type="submit" value="入力"></td>
			</tr>
		</tfoot>
		</table>
	</form>
</section>

kEditRowWin2;
	} else {
		echo $msg;
	}
	include("prog/html11.inc");
}
//---------------------------------------------------------------------------
/**
 * 新規データを作る
 *
 * @param string{} $pFields : カラムの名前
 * @param string $_COOKIE[kUserName] : 編集者名
 *
 * @return string [] : 空の入力データ
 */
function NewEditData($pFields)
{
	$data = array();
	foreach ($pFields as $val) {
		$data[$val] = "";
	}
	if (isset($data['編集者'])) {
		$data['編集者'] = $_COOKIE[kUserName];
	}
	return ($data);
}
//---------------------------------------------------------------------------
/**
 * 編集データを得る
 *
 * @param string $_REQUEST['Table'] : 選択しているテーブルの番号
 * @param string $_REQUEST['PrimarykeyVal'] : プライマリーキーの値
 * @param string $pPrimarykeyName : プライマリーキーの名前
 *
 * @return string[] : 編集するデータ
 * @return string : データがないというメッセージ
 */
function GetEditData($pPrimarykeyName)
{
	global $gPDOOption, $gDsn;
	global $gTables;
	//---------------処理部---------------
	$pdo = new PDO($gDsn, asuna_USER, asuna_PASS, $gPDOOption);

	$sql = sprintf("SELECT * FROM `%s` WHERE `%s` = :dt ", $gTables[$_REQUEST['Table']], $pPrimarykeyName);	//プレースフォルダはカラムの値にしか適応できない
	$stmt = $pdo->prepare($sql);
	$stmt->bindValue(':dt', $_REQUEST['PrimarykeyVal'], PDO::PARAM_STR);
	$stmt->execute();

	$data = $stmt->fetchAll(PDO::FETCH_ASSOC);
	if (($data === false) || (empty($data))) {
		$msg = sprintf("%s のデータが見つかりません", htmlspecialchars($_REQUEST['PrimarykeyVal'], ENT_QUOTES, 'UTF-8'));
		return ($msg);
	}
	if (isset($data[0]['編集者']) && ($_REQUEST['Cmd'] != '表示')) {
		$data[0]['編集者'] = $_COOKIE[kUserName] . "\n" . $data[0]['編集者'];
	}
	return ($data[0]);
}
//---------------------------------------------------------------------------
/**
 * 編集するテーブルのデータを作る
 *
 * @param string $_REQUEST['Cmd'] : コマンド 新規 , 編集 , 複製
 * @param string[][] $pColumns : カラムの情報
 * @param string[] $pEditData : 編集データ
 * @param string $pPrimarykeyName : プライマリーキーの名前
 *
 * @return string[] : 編集するテーブルのボディーデータ
 */
function MakeEditTable($pColumns, $pEditData, $pPrimarykeyName)
{
	//---------------処理部---------------
	$body = array();

	foreach ($pColumns as $val) {	//すべてのカラムについて
		if (false !== strpos($val['Comment'], 'required')) {			//required属性
			$required = 'required';
		} else {
			$required = '';
		}

		$readonly = '';

		if (false !== strpos($val['Comment'], 'readonly')) {			//readonly属性
			$readonly = 'readonly';
		}

		switch ($val['Field']) {										//readonly属性
			case '編集者':
			case '更新回数':
			case '更新日時':
			case '登録日時':
				$readonly = 'readonly';
				break;
		}

		$extra = strtolower($val['Extra']);
		if (false !== strpos($extra, 'auto_increment')) {				//readonly属性
			$readonly = 'readonly';
		}

		if (false !== strpos($extra, 'on update current_timestamp')) {	//readonly属性
			$readonly = 'readonly';
		}

		if (($_REQUEST['Cmd'] == '編集') && ($val['Field'] == $pPrimarykeyName)) {	//readonly属性
			$readonly = 'readonly';
		}

		if (($_REQUEST['Cmd'] == '複製') && ($val['Field'] == $pPrimarykeyName)) {
			$pEditData[$val['Field']] = "";
		}

		$type_string = explode(' ', $val['Type']);
		$type = preg_replace('/\(.+\)/', '', $type_string[0]);	//varchar(20) -> varchar
		$type = strtolower($type);
		switch ($type) {			//MySQLの型によって入力エレメントを変える
			case 'tinyint':
			case 'smallint':
			case 'mediumint':
			case 'int':
			case 'integer':
			case 'bigint':
				$elm = input_element('number', $val['Field'], $pEditData[$val['Field']], $required, $readonly);		//整数
				break;
			case 'float':
			case 'real':
			case 'double':
			case 'decimal':
				$elm = input_element('real', $val['Field'], $pEditData[$val['Field']], $required, $readonly);		//実数
				break;
			case 'date':
				$elm = input_element('date', $val['Field'], $pEditData[$val['Field']], $required, $readonly);		//日付
				break;
			case 'time':
				$elm = input_element('time', $val['Field'], $pEditData[$val['Field']], $required, $readonly);		//時刻
				break;
			case 'datetime':
			case 'timestamp':	//Microsoft Edgeはinput の datetime , datetime-localに不完全対応(2020/10)
				$elm = input_element('datetime-local', $val['Field'], $pEditData[$val['Field']], $required, $readonly);	//日時
				break;
			case 'char':
			case 'varchar':																							//文字列
				$tp = input_type($val);				//コメントに書いてあるinput typeを調べる
				if ($tp == "textarea") {
					$elm = textarea_element($val['Field'], $pEditData[$val['Field']], $required, $readonly);
				} else {
					$elm = input_element($tp, $val['Field'], $pEditData[$val['Field']], $required, $readonly);
				}
				break;
			case 'tinytext':
			case 'text':
			case 'mediumtext':
			case 'longtext':																						//文字列
				$elm = textarea_element($val['Field'], $pEditData[$val['Field']], $required, $readonly);
				break;
			case 'enum':
				$elm = enum_element($val['Field'], $pEditData[$val['Field']], $val['Type'], $required, $readonly);	//列挙型
				break;
			default:
				$elm = input_element('text', $val['Field'], $pEditData[$val['Field']], $required, $readonly);
		}
		$body[] = sprintf("<tr><td>%s</td><td>%s</td></tr>\n", $val['Field'], $elm);
	}
	return ($body);
}
//---------------------------------------------------------------------------
/**
 * input エレメントを作る
 *
 * @param string $pType : inputエレメントのタイプ名
 * @param string $pName : name
 * @param string $pVal : value
 * @param string $pRequired : required
 * @param string $pReadonly : readonly
 *
 * @return string : input エレメントの文字列
 */
function input_element($pType, $pName, $pVal, $pRequired, $pReadonly)
{
	//---------------処理部---------------
	if ($pType == 'real') {		//input type に'real'はない
		$additional = 'class="right" pattern="^-?\d+(\.\d+)?$" title="実数を入力してください"';
		$pType = 'text';
	} else {
		$additional = '';
	}
	$str = sprintf("<input type=\"%s\" name=\"%s\" value=\"%s\" %s %s %s>", $pType, $pName, $pVal, $pRequired, $pReadonly, $additional);
	return ($str);
}
//---------------------------------------------------------------------------
/**
 * textarea エレメントを作る
 *
 * @param string $pName : name textarea エレメント
 * @param string $pVal : value
 * @param string $pRequired : required
 * @param string $pReadonly : readonly
 *
 * @return string : textarea エレメントの文字列
 */
function textarea_element($pName, $pVal, $pRequired, $pReadonly)
{
	//---------------処理部---------------
	$str = sprintf("<textarea name=\"%s\" %s %s>%s</textarea>", $pName, $pRequired, $pReadonly, $pVal);
	return ($str);
}
//---------------------------------------------------------------------------
/**
 * enum エレメントを作る
 *
 * @param string $pName : name enum エレメント
 * @param string $pVal : value
 * @param string $pTypeStr : 型（列挙する項目を含んでいる）
 * @param string $pRequired : required
 * @param string $pReadonly : readonly
 *
 * @return string : プルダウンメニュー
 */
function enum_element($pName, $pVal, $pTypeStr, $pRequired, $pReadonly)
{
	$options = array();
	//---------------処理部---------------
	preg_match_all('/\'(.*?)\'/', $pTypeStr, $matches);	//$pTypeStr ex. enum('管理者','一般')
	$opt = $matches[1];									//[1]に切り分けられたデータが入る
	$options[] = "<option value=\"\"></option>";
	foreach ($opt as $val) {
		if ($val == $pVal) {
			$options[] = sprintf("<option value=\"%s\" selected>%s</option>", $val, $val);
		} else {
			$options[] = sprintf("<option value=\"%s\">%s</option>", $val, $val);
		}
	}
	$str = sprintf("<select name=\"%s\" %s %s>\n", $pName, $pRequired, $pReadonly);
	$str = $str . implode("\n", $options);
	$str = $str . "</select>\n";
	return ($str);
}
//---------------------------------------------------------------------------
/**
 * char,varcharタイプの場合は、カラムのコメントに従ってinput typeを返す
 *
 * @param string[] $col : カラムの情報
 * @return input typeの文字列
 */
function input_type($col)
{
	$pattern = '/search|tel|url|email|password|textarea|text/';		//HTML5のinput type
	//---------------処理部---------------
	if (1 == preg_match($pattern, $col['Comment'], $matches)) {		//コメントの中に検索文字列があった
		return ($matches[0]);
	}

	preg_match('/\d+/', $col['Type'], $num_str);
	$num = intval($num_str[0]);
	if ($num > kTextArea) {
		return ("textarea");
	}
	return ("text");
}
//---------------------------------------------------------------------------
/**
 * 行を表示する
 *
 * @param string $_REQUEST['Table'] : 選択しているテーブルの番号
 * @param string $_REQUEST['PrimarykeyName'] : プライマリーキーの名前
 * @param string $_REQUEST['PrimarykeyVal'] : プライマリーキーの値
 *
 */
function ViewRowWin()
{
	global $gTables;
	//---------------処理部---------------
	$msg = '';
	$tbody = array();
	try {
		$row = GetEditData($_REQUEST['PrimarykeyName']);				//編集データを得る
		if (is_array($row)) {
			foreach ($row as $key => $val) {
				$key = htmlspecialchars($key,       ENT_QUOTES, 'UTF-8');
				$val = nl2br(htmlspecialchars($val, ENT_QUOTES, 'UTF-8'), false);
				$tbody[] = sprintf("<tr><td>%s</td><td>%s</td></tr>\n", $key, $val);
			}
			$tbody[] = sprintf("<tr><td colspan=\"2\" class=\"right\"><input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></td></tr>\n");
		} else {
			$msg = sprintf("<div class=\"error msgbox\">%s <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>", $row);
		}
		WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], $msg);
	} catch (PDOException $e) {
		$err = sprintf("%s\n(%s  %d)", $e->getMessage(), $e->getFile(), $e->getLine());
		$id = WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], '', $_REQUEST['Cmd'], $err);
		$msg = "<div class=\"error msgbox\">データベースへの接続に失敗しました。(ログID:{$id}) <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
	}
	//---------------表示部---------------
	include("prog/html01.inc");
	printf("<header>\nデータ表示\n</header>\n\n");
	printf("\n<section>\n\n");
	if ($msg == '') {
		//テーブルの表示
		printf("<table>\n<tbody>\n");
		foreach ($tbody as $val) {
			echo $val;
		}
		printf("</tbody>\n</table>\n");
	} else {
		echo $msg;
	}
	printf("\n</section>\n");
	include("prog/html11.inc");
}
//---------------------------------------------------------------------------
/**
 * 削除確認ウインドウを作る
 *
 * @param string $_REQUEST['Table'] : 選択しているテーブルの番号
 * @param string $_REQUEST['PrimarykeyName'] : プライマリーキーの名前
 * @param string $_REQUEST['PrimarykeyVal'] : プライマリーキーの値
 *
 */
function DelRowWin()
{
	global $gTables;
	//---------------処理部---------------
	$msg = '';
	$mod_count = "";
	$tbody = array();
	try {
		$row = GetEditData($_REQUEST['PrimarykeyName']);				//編集データを得る
		if (is_array($row)) {
			foreach ($row as $key => $val) {
				$key = htmlspecialchars($key,       ENT_QUOTES, 'UTF-8');
				$val = nl2br(htmlspecialchars($val, ENT_QUOTES, 'UTF-8'), false);
				$tbody[] = sprintf("<tr><td>%s</td><td>%s</td></tr>\n", $key, $val);
				if ($key == "更新回数") {								//長時間トランザクション対策
					$mod_count = sprintf("<input type=\"hidden\" name=\"更新回数\" value=\"%d\">", $val);
				}
			}
		} else {
			$msg = sprintf("<div class=\"error msgbox\">%s <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>", $row);
		}
		WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], "データ削除表示", "");
	} catch (PDOException $e) {
		$err = sprintf("%s\n(%s  %d)", $e->getMessage(), $e->getFile(), $e->getLine());
		$id = WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], '', "データ削除表示", $err);
		$msg = "<div class=\"error msgbox\">データベースへの接続に失敗しました。(ログID:{$id}) <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
	}
	$table   = htmlspecialchars($_REQUEST['Table'],          ENT_QUOTES, 'UTF-8');
	$keyname = htmlspecialchars($_REQUEST['PrimarykeyName'], ENT_QUOTES, 'UTF-8');
	$keyval  = htmlspecialchars($_REQUEST['PrimarykeyVal'],  ENT_QUOTES, 'UTF-8');
	//---------------表示部---------------
	include("prog/html01.inc");
	printf("\n<script src=\"prog/asuna02.js\"></script>\n");
	printf("<header>\nデータ削除\n</header>\n\n");
	printf("\n<section>\n\n");
	if ($msg == '') {
		//テーブルの表示
		print <<< kDelRowWin1
<form action="index.php" id="DelRowForm" method="post">
	<input type="hidden" name="Cmd" value="行削除">
	<input type="hidden" name="Table" value="{$table}">
	<input type="hidden" name="PrimarykeyName" value="{$keyname}">
	<input type="hidden" name="PrimarykeyVal" value="{$keyval}">
	{$mod_count}
	<table>
		<tbody>

kDelRowWin1;
		foreach ($tbody as $val) {
			echo $val;
		}
		print <<< kDelRowWin2
		</tbody>
		<tfoot>
			<tr class="error">
			<td colspan="2" class="right">
			<input type="button" value="閉じる" onclick="window.close();">
			<input type="button" id="DelRowButton" value="削除"></td>
			</tr>
		</tfoot>
	</table>
</form>

kDelRowWin2;
	} else {
		echo $msg;
	}
	printf("\n</section>\n");
	include("prog/html11.inc");
}
//---------------------------------------------------------------------------
/**
 * 行を削除する
 *
 * @param string $_REQUEST['Table'] : 選択しているテーブルの番号
 * @param string $_REQUEST['PrimarykeyName'] : プライマリーキーの名前
 * @param string $_REQUEST['PrimarykeyVal'] : プライマリーキーの値
 */
function DeleteRow()
{
	global $gPDOOption, $gDsn;
	global $gTables;
	//---------------処理部---------------
	if (isset($_COOKIE[kUserLevel]) && (($_COOKIE[kUserLevel] == '管理者') || ($_COOKIE[kUserLevel] == '一般'))) {
		try {
			$pdo = new PDO($gDsn, asuna_USER, asuna_PASS, $gPDOOption);

			$pdo->beginTransaction();
			if (empty($_REQUEST['更新回数'])) {	//更新回数（長時間トランザクション）がない場合
				$sql = sprintf("DELETE FROM `%s` WHERE `%s` = :dt ", $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyName']);
				$stmt = $pdo->prepare($sql);
				$stmt->bindValue(':dt', $_REQUEST['PrimarykeyVal'], PDO::PARAM_STR);
			} else {
				$sql = sprintf("DELETE FROM `%s` WHERE (`%s` = :dt) AND (`更新回数` = :ct) ", $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyName']);
				$stmt = $pdo->prepare($sql);
				$stmt->bindValue(':dt', $_REQUEST['PrimarykeyVal'], PDO::PARAM_STR);
				$stmt->bindValue(':ct', $_REQUEST['更新回数'], PDO::PARAM_STR);
			}
			$stmt->execute();
			$pdo->commit();
			$num = $stmt->rowCount();
			if ($num == 1) {
				$msg = "<div class=\"message msgbox\">データを削除しました。<input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
				WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], "成功");
			} else {
				$msga = "削除しようとしたデータは、別のＰＣによって書き換えられています。";
				$msg = "<div class=\"error msgbox\">{$msga}<input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
				WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], $msga);
			}
		} catch (PDOException $e) {
			$pdo->rollBack();
			$err = sprintf("%s\n(%s  %d)", $e->getMessage(), $e->getFile(), $e->getLine());
			$id = WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], $err);
			$msg = "<div class=\"error msgbox\">データベースへの接続に失敗しました。(ログID:{$id}) <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
		}
	} else {
		$msg = "<div class=\"message msgbox\">「閲覧のみ」ユーザーはデータを削除できません。<input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
		WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], '', $_REQUEST['Cmd'], "失敗(閲覧のみユーザー)");
	}
	//---------------表示部---------------
	include("prog/html01.inc");
	printf("<script>window.opener.$('#search').click();</script>\n<header>\nデータ削除\n</header>\n\n<section>\n\n");
	echo nl2br($msg, false);
	printf("\n</section>\n");
	include("prog/html11.inc");
}
//---------------------------------------------------------------------------
/**
 * 行を追加する
 *
 * @param string $_REQUEST['Cmd'] : '行追加'
 * @param string $_REQUEST['Table'] : 選択しているテーブルの番号
 * @param string $_REQUEST[] : 追加するデータ
 */
function InsertRow()
{
	global $gPDOOption, $gDsn;
	global $gTables;
	//---------------処理部---------------
	try {
		$column = array();
		$params = array();
		GetColumns($fileld, $columns);				//カラム名を得る

		if (isset($_REQUEST['更新回数'])) 	$_REQUEST['更新回数'] = 1;	//初回記録
		$fileld = array_diff($fileld, array('更新日時', '登録日時'));				//更新日時はデータベースが自動記録(CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP)
		$fileld = array_values($fileld);
		if (IsPKeyAutoInc($_REQUEST['PrimarykeyName'], $columns)) {		//新規入力でautoincrementは空にしておく
			$fileld = array_diff($fileld, array($_REQUEST['PrimarykeyName']));
			$fileld = array_values($fileld);
		}

		foreach ($fileld as $name) {				//入力データを整える
			if (empty($_REQUEST[$name])) continue;	//空の入力は省く
			$column[] = $name;						//カラム名
			$params[] = $_REQUEST[$name];			//値
		}

		$pdo = new PDO($gDsn, asuna_USER, asuna_PASS, $gPDOOption);
		$pdo->beginTransaction();					//トランザクション処理 MyISAMでは効かない InnoDBならば有効

		$insert_str = MakeInsertStr($column);
		$sql = "INSERT INTO `" . $gTables[$_REQUEST['Table']] . "` " . $insert_str;
		$stmt = $pdo->prepare($sql);
		$stmt->execute($params);
		$id = $pdo->lastInsertId();
		$pdo->commit();
		$msg  = "<div class=\"message msgbox\">データを追加しました。<input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
		WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $id, $_REQUEST['Cmd'], "成功");
	} catch (PDOException $e) {
		$pdo->rollBack();
		$err = sprintf("%s\n(%s  %d)", $e->getMessage(), $e->getFile(), $e->getLine());
		$id = WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], '', $_REQUEST['Cmd'], $err);
		$msg = "<div class=\"error msgbox\">データベースへの接続に失敗しました。(ログID:{$id})<input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
	}
	//---------------表示部---------------
	include("prog/html01.inc");
	printf("<script>window.opener.$('#search').click();</script>\n<header>\nデータ追加\n</header>\n\n<section>\n\n");
	echo nl2br($msg, false);
	printf("\n</section>\n");
	include("prog/html11.inc");
}
//---------------------------------------------------------------------------
/**
 * 行を変更する
 *
 * @param string $_REQUEST['Cmd'] : '行追加'
 * @param string $_REQUEST['Table'] : 選択しているテーブルの番号
 * @param string $_REQUEST[] : 更新するデータ
 */
function UpdateRow()
{
	global $gPDOOption, $gDsn;
	global $gTables;
	//---------------処理部---------------
	try {
		$sets = array();
		$params = array();
		GetColumns($fileld, $columns);						//カラム名を得る

		$fileld = array_diff($fileld, array('更新日時', '登録日時'));	//更新日時はデータベースが自動記録(CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP)
		$fileld = array_values($fileld);

		foreach ($fileld as $val) {
			$sets[] = '`' . $val . '`' . " = ? ";			//カラム名 = ?
			$params[] = $_REQUEST[$val];					//値
		}
		if (isset($_REQUEST['更新回数'])) {					//長時間トランザクション対応
			$sets[] = '`更新回数` = `更新回数` + 1 ';
			$where_str  = sprintf(" ((`%s` = '%s') AND (`更新回数` = %d)) ", $_REQUEST['PrimarykeyName'], $_REQUEST['PrimarykeyVal'], $_REQUEST['更新回数']);
		} else {
			$where_str  = sprintf(" (`%s` = '%s') ", $_REQUEST['PrimarykeyName'], $_REQUEST['PrimarykeyVal']);
		}
		$update_str = implode(',', $sets);

		$pdo = new PDO($gDsn, asuna_USER, asuna_PASS, $gPDOOption);
		$pdo->beginTransaction();
		$sql = "UPDATE `" . $gTables[$_REQUEST['Table']] . "` SET {$update_str} WHERE {$where_str} ";
		$stmt = $pdo->prepare($sql);
		$stmt->execute($params);
		$pdo->commit();
		$num = $stmt->rowCount();
		if ($num == 1) {
			$msg = "<div class=\"message msgbox\">データを変更しました。<input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
			WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], "成功");
		} else {
			$msga = "変更しようとしたデータは、別のＰＣによって書き換えられているか、\n文字数超過、データ型不一致、変更点がないなどの理由で、更新できませんでした。";
			$msg = "<div class=\"error msgbox\">{$msga}<input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
			WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], $msga);
		}
	} catch (PDOException $e) {
		$pdo->rollBack();
		$err = sprintf("%s\n(%s  %d)", $e->getMessage(), $e->getFile(), $e->getLine());
		$id = WriteLog($_COOKIE[kUserID], $_COOKIE[kSection], $_COOKIE[kUserName], $gTables[$_REQUEST['Table']], $_REQUEST['PrimarykeyVal'], $_REQUEST['Cmd'], $err);
		$msg = "<div class=\"error msgbox\">データベースへの接続に失敗しました。(ログID:{$id}) <input type=\"button\" value=\"閉じる\" onClick=\"window.close()\"></div>\n";
	}
	//---------------表示部---------------
	include("prog/html01.inc");
	printf("<script>window.opener.$('#search').click();</script>\n<header>\nデータ変更\n</header>\n\n<section>\n\n");
	echo nl2br($msg, false);
	printf("\n</section>\n");
	include("prog/html11.inc");
}
//---------------------------------------------------------------------------
/**
 * プライマリーキーがオートインクリメントかどうか
 *
 * @param string $pPrimarykeyName : プライマリーキーの名前
 * @param string[] $pColumns : カラムの情報
 *
 * @return true : オートインクリメント、false : オートインクリメントではない
 */
function IsPKeyAutoInc($pPrimarykeyName, $pColumns)
{
	foreach ($pColumns as $val) {
		$extra = strtolower($val['Extra']);
		if (($val['Field'] == $pPrimarykeyName) && (false !== strpos($extra, 'auto_increment'))) {
			return (true);
		}
	}
	return (false);
}
//---------------------------------------------------------------------------
